<template>
  <div>
    <div class="row">
      <div class="col d-flex justify-content-end">
        <a-button
          type="dashed"
          @click="getUsers()"
          class="d-flex align-items-center"
        >
          <a-icon type="reload" />Recarregar
        </a-button>
        <a-button
          type="primary"
          @click="handleShowDrawerForm"
          class="d-flex d-flex align-items-center"
        >
          <a-icon type="plus" />Cadastrar novo
        </a-button>
      </div>
    </div>
    <portfolio-table
      :portfolios="portfolios"
      :loading="loading"
      @emit-show-drawer-form="handleShowDrawerForm"
      @emit-show-drawer-view="handleShowDrawerView"
      @emit-show-drawer-edit="handleShowDrawerEdit"
    />
    <portfolio-drawer-form
      :showDrawer="drawerForm"
      :portfolio="portfolio"
      @emit-save-user="postUsers"
      @emit-close-drawer="handleCloseDrawerForm"
    />
    <portfolio-drawer-view
      :drawerView="drawerView"
      :portfolio="portfolio"
      @emit-close-drawer="handleCloseDrawerView"
    />
  </div>
</template>

<script>
import Portfolio from "@/model/portfolio/portfolio";
import PortfolioTable from "./portfolio-table";
import PortfolioDrawerForm from "./portfolio-drawer-form";
import PortfolioDrawerView from "./portfolio-drawer-view";
export default {
  components: { PortfolioTable, PortfolioDrawerForm, PortfolioDrawerView },
  data() {
    return {
      drawerForm: false,
      drawerView: false,
      closeDrawerView: false,
      closeDrawerForm: false,
      loading: false,
      portfolios: [
        {
          id: 1,
          title: "Portfólio 1",
        },
        {
          id: 2,
          title: "Portfólio 2",
        },
        {
          id: 3,
          title: "Portfólio 3",
        },
      ],
      portfolio: [],
    };
  },
  methods: {
    async getUsers() {
      this.loading = true;
      try {
        setTimeout(() => {
          this.loading = false;
        }, 1000);
      } catch (error) {
        console.log(error);
        this.loading = false;
      }
    },
    async postUsers() {},
    // Drawer FORM
    handleShowDrawerForm() {
      this.drawerForm = true;
      this.portfolio = new Portfolio();
    },
    handleCloseDrawerForm(closeDrawer) {
      this.drawerForm = closeDrawer;
      this.portfolio = new Portfolio();
    },
    // Drawer EDIT
    handleShowDrawerEdit(portfolio) {
      this.drawerForm = true;
      this.portfolio = portfolio;
    },
    handleCloseDrawerEdit(closeDrawer) {
      this.drawerForm = closeDrawer;
      this.portfolio = new Portfolio();
    },
    // Drawer VIEW
    handleShowDrawerView(portfolio) {
      this.portfolio = portfolio;
      this.drawerView = true;
    },
    handleCloseDrawerView(closeDrawer) {
      this.drawerView = closeDrawer;
    },
  },
};
</script>
